// FileView.cpp : CFileView ʵ
//

#include "stdafx.h"
#include "File.h"

#include "FileDoc.h"
#include "FileView.h"
#include <fstream>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CFileView

IMPLEMENT_DYNCREATE(CFileView, CView)

BEGIN_MESSAGE_MAP(CFileView, CView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_READ, &CFileView::OnRead)
	ON_COMMAND(ID_WRITE, &CFileView::OnWrite)
	ON_COMMAND(ID_READCPLUSPLUS, &CFileView::OnReadcplusplus)
	ON_COMMAND(ID_WRITECPLUSPLUS, &CFileView::OnWritecplusplus)
	ON_COMMAND(ID_READAPI, &CFileView::OnReadapi)
	ON_COMMAND(ID_WRITEAPI, &CFileView::OnWriteapi)
	ON_COMMAND(ID_READMFC, &CFileView::OnReadmfc)
	ON_COMMAND(ID_WRITEMFC, &CFileView::OnWritemfc)
	ON_COMMAND(ID_WRITEDLG, &CFileView::OnWritedlg)
	ON_COMMAND(ID_READDLG, &CFileView::OnReaddlg)
	ON_COMMAND(ID_READWRITEWINDOTINI, &CFileView::OnREADWRITEWINDOTINI)
	ON_COMMAND(ID_READREG, &CFileView::OnReadreg)
	ON_COMMAND(ID_WRITEREG, &CFileView::OnWritereg)
	ON_COMMAND(ID_DELETEREGITEM, &CFileView::OnDeleteregitem)
END_MESSAGE_MAP()

// CFileView /

CFileView::CFileView()
{
	// TODO: ڴ˴ӹ

}

CFileView::~CFileView()
{
}

BOOL CFileView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸
	//  CREATESTRUCT cs ޸Ĵʽ

	return CView::PreCreateWindow(cs);
}

// CFileView 

void CFileView::OnDraw(CDC* /*pDC*/)
{
	CFileDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ڴ˴Ϊӻƴ
}


// CFileView ӡ

BOOL CFileView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return DoPreparePrinting(pInfo);
}

void CFileView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӶĴӡǰеĳʼ
}

void CFileView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Ӵӡе
}


// CFileView 

#ifdef _DEBUG
void CFileView::AssertValid() const
{
	CView::AssertValid();
}

void CFileView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFileDoc* CFileView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFileDoc)));
	return (CFileDoc*)m_pDocument;
}
#endif //_DEBUG


// CFileView Ϣ

void CFileView::OnRead()
{
	// TODO: ڴ
	FILE *pFile = fopen("1.txt", "r");
	/*char ch[100 * 1024];
	memset(ch, 0, sizeof(ch));
	fread(ch, 1, sizeof(ch), pFile);
	fclose(pFile);
	MessageBox(ch);*/
	
	fseek(pFile, 0, SEEK_END);
	int len = ftell(pFile);
	char *pBuf;
	pBuf = new char[len + 1];
	rewind(pFile);
	fread(pBuf, 1, len, pFile);
	pBuf[len] = '\0';
	fclose(pFile);
	MessageBox(pBuf);

	//ƶдıдͬ, ıΪλ13(0xD) 10(0xA)
	
}

void CFileView::OnWrite()
{
	// TODO: ڴ
	FILE *pFile = fopen("1.txt", "a+");
	fseek(pFile, 0, SEEK_SET);
	fwrite("test", 1, strlen("test"), pFile);
	fflush(pFile);
	fclose(pFile);
}

void CFileView::OnReadcplusplus()
{
	
	// TODO: ڴ
	std::fstream fs("2.txt");
	char ch[200];
	memset(ch, 0, 100);
	//fs.read(ch, 100);
	fs >> ch;
	fs.close();
	MessageBox(ch);
	
}

void CFileView::OnWritecplusplus()
{
	std::fstream fs("2.txt", std::ios::in | std::ios::out | std::ios::trunc);
	fs.write("test", strlen("test"));
	fs << "test123" << std::endl;
	fs.close();
	// TODO: ڴ
}

void CFileView::OnReadapi()
{
	// TODO: ڴ
	HANDLE hFile;
	hFile = ::CreateFile("3.txt", GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	char ch[500];
	DWORD dwReads;
	::ReadFile(hFile, ch, 500, &dwReads, NULL);
	ch[dwReads] = 0;
	CloseHandle(hFile);
	MessageBox(ch);
}

void CFileView::OnWriteapi()
{
	// TODO: ڴ
	HANDLE hFile;
	hFile = ::CreateFile("3.txt", GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
	DWORD dwWrites;
	::WriteFile(hFile, "mytest", strlen("mytest"), &dwWrites, NULL);
	CloseHandle(hFile);
}

void CFileView::OnReadmfc()
{
	// TODO: ڴ
	CFile file("4.txt", CFile::modeRead);
	char *pBuf;
	DWORD dwFileLen;
	dwFileLen = file.GetLength();
	pBuf = new char[dwFileLen + 1];
	pBuf[dwFileLen] = 0;
	file.Read(pBuf, dwFileLen);
	file.Close();
	MessageBox(pBuf);
}

void CFileView::OnWritemfc()
{
	// TODO: ڴ
	CFile file("4.txt", CFile::modeCreate | CFile::modeWrite);
	char ch[200] = "tester";
	file.Write(ch, strlen(ch));
	file.Close();
}

void CFileView::OnWritedlg()
{
	// TODO: ڴ
	CFileDialog dlg(FALSE);
	dlg.m_ofn.lpstrTitle = "ҵļԻ";
	dlg.m_ofn.lpstrFilter = "Text Files(*.txt)\0*.txt\0All Files(*.*)\0*.*\0\0";
	dlg.m_ofn.lpstrDefExt = "txt";
	if(dlg.DoModal() == IDOK)
	{
		CString strFileName = dlg.GetPathName(); //GetFileName·ļ
		CFile file(strFileName, CFile::modeCreate | CFile::modeWrite);
		file.Write("дļ", strlen("дļ"));
		file.Close();
	}
}

void CFileView::OnReaddlg()
{
	// TODO: ڴ
	CFileDialog dlg(TRUE);
	dlg.m_ofn.lpstrTitle = "ҵļ򿪶Ի";
	dlg.m_ofn.lpstrFilter = "Text Files(*.txt)\0*.txt\0All Files(*.*)\0*.*\0\0";
	if(dlg.DoModal() == IDOK)
	{
		CFile file(dlg.GetPathName(), CFile::modeRead);
		DWORD dwLen = file.GetLength();
		char * pBuf;
		pBuf = new char[dwLen + 1];
		pBuf[dwLen] = 0;
		file.Read(pBuf, dwLen);
		file.Close();
		MessageBox(pBuf);
	}
}

void CFileView::OnREADWRITEWINDOTINI()
{
	// TODO: ڴ
	//޸win.ini
	::WriteProfileString("ҵӦ", "testkey", "testvalue");
	
	/*LPSTR lp = new char[200];
	::GetProfileString("ҵӦ", "testkey", "defaultvalue", lp, 20);
	delete []lp;*/
	CString str;
	::GetProfileString("ҵӦ", "testkey", "defaultvalue", str.GetBuffer(100), 100);
	//str.ReleaseBuffer(); //getbuffصַָʱ
	MessageBox(str);


	//һCFileAppInitInstanceעϢ, CAppҲWriteProfileString,
	//win2kϵͳд뵽ע, µϵͳдwin.ini
}

void CFileView::OnReadreg()
{
	// TODO: ڴ
	
	CString str;
	LONG lSize;
	//ȡȱʡֵ
	RegQueryValue(HKEY_LOCAL_MACHINE, "Software\\test\\admin", str.GetBuffer(200), &lSize);
	MessageBox(str);

	//ȡֵ
	HKEY hKey;
	RegOpenKey(HKEY_LOCAL_MACHINE, "Software\\test\\admin", &hKey);
	DWORD dwType;
	DWORD dwValue;
	DWORD dwAge;
	RegQueryValueEx(hKey, "age", 0, &dwType, (LPBYTE)&dwAge, &dwValue);
	CString str2;
	str2.Format("age=%d", dwAge);
	MessageBox(str2);
}

void CFileView::OnWritereg()
{
	HKEY hKey;
	RegCreateKey(HKEY_LOCAL_MACHINE, "Software\\test\\admin", &hKey);
	//ڶΪ, û, ȱʡֵ
	//ֻREG_SZ(ַ), ͵ҪRegSetValueEx
	RegSetValue(hKey, NULL, REG_SZ, "wangwu", strlen("wangwu"));
	//д
	DWORD dwAge = 30;
	RegSetValueEx(hKey, "age", 0, REG_DWORD, (CONST BYTE*)&dwAge, 4);
	RegCloseKey(hKey);
}

void CFileView::OnDeleteregitem()
{
	//ɾKey
	//RegDeleteKey(HKEY_LOCAL_MACHINE, "Software\\test\\admin");
	//ɾֵ
	HKEY hKey;
	RegOpenKey(HKEY_LOCAL_MACHINE, "Software\\test\\admin", &hKey);
	RegDeleteValue(hKey, "age");

}
